Codeforces Round #277 (Div. 2)
A. Calculating Function
time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

For a positive integer n let's define a function f:

f(n) =  - 1 + 2 - 3 + .. + ( - 1)nn

Your task is to calculate f(n) for a given integer n.

Input

The single line contains the positive integer n (1 ≤ n ≤ 1015).

Output

Print f(n) in a single line.

Sample test(s)
input
4

output
2

input
5

output
-3

Note

f(4) =  - 1 + 2 - 3 + 4 = 2

f(5) =  - 1 + 2 - 3 + 4 - 5 =  - 3

简单公式:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>using namespace std;typedef long long int LL;LL n;int main()
{cin>>n;if(n%2==0){LL t=n/2;cout<<t<<endl;}else{LL t=(n-1)/2;cout<<t-n<<endl;}return 0;
}

B. OR in Matrix
time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Let's define logical OR as an operation on two logical values (i. e. values that belong to the set {0, 1}) that is equal to 1 if either or both of the logical values is set to 1, otherwise it is 0. We can define logical OR of three or more logical values in the same manner:

 where  is equal to 1 if some ai = 1, otherwise it is equal to 0.

Nam has a matrix A consisting of m rows and n columns. The rows are numbered from 1 to m, columns are numbered from 1 to n. Element at row i(1 ≤ i ≤ m) and column j (1 ≤ j ≤ n) is denoted as Aij. All elements of A are either 0 or 1. From matrix A, Nam creates another matrix B of the same size using formula:

.

(Bij is OR of all elements in row i and column j of matrix A)

Nam gives you matrix B and challenges you to guess matrix A. Although Nam is smart, he could probably make a mistake while calculating matrix B, since size of A can be large.

Input

The first line contains two integer m and n (1 ≤ m, n ≤ 100), number of rows and number of columns of matrices respectively.

The next m lines each contain n integers separated by spaces describing rows of matrix B (each element of B is either 0 or 1).

Output

In the first line, print "NO" if Nam has made a mistake when calculating B, otherwise print "YES". If the first line is "YES", then also print m rows consisting of n integers representing matrix A that can produce given matrix B. If there are several solutions print any one.

Sample test(s)
input
2 2
1 0
0 0

output
NO

input
2 3
1 1 1
1 1 1

output
YES
1 1 1
1 1 1

input
2 3
0 1 0
1 1 1

output
YES
0 0 0
0 1 0

水题:将A里全部可能是1的点加上就能够了
#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>using namespace std;int n,m;int B[220][220];
int A[220][220];
bool vis[220][220];bool check(int x,int y)
{bool flag=true;for(int i=0;i<m&&flag;i++){if(vis[x][i]==false&&B[x][i]==0) flag=false;}for(int i=0;i<n&&flag;i++){if(vis[i][y]==false&&B[i][y]==0) flag=false;}return flag;
}void CL(int x,int y)
{for(int i=0;i<m;i++)vis[x][i]=true;for(int i=0;i<n;i++)vis[i][y]=true;
}int main()
{cin>>n>>m;for(int i=0;i<n;i++)for(int j=0;j<m;j++)cin>>B[i][j];for(int i=0;i<n;i++){for(int j=0;j<m;j++){if(check(i,j))///ONE{A[i][j]=1;CL(i,j);}}}bool flag=true;for(int i=0;i<n&&flag;i++)for(int j=0;j<m&&flag;j++)if(B[i][j]==1&&vis[i][j]==0) flag=false;if(flag){puts("YES");for(int i=0;i<n;i++){for(int j=0;j<m;j++)cout<<A[i][j]<<" ";cout<<endl;}}else puts("NO");return 0;
}

C. Palindrome Transformation
time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Nam is playing with a string on his computer. The string consists of n lowercase English letters. It is meaningless, so Nam decided to make the string more beautiful, that is to make it be a palindrome by using 4 arrow keys: left, right, up, down.

There is a cursor pointing at some symbol of the string. Suppose that cursor is at position i (1 ≤ i ≤ n, the string uses 1-based indexing) now. Left and right arrow keys are used to move cursor around the string. The string is cyclic, that means that when Nam presses left arrow key, the cursor will move to position i - 1 if i > 1 or to the end of the string (i. e. position n) otherwise. The same holds when he presses the right arrow key (if i = n, the cursor appears at the beginning of the string).

When Nam presses up arrow key, the letter which the text cursor is pointing to will change to the next letter in English alphabet (assuming that alphabet is also cyclic, i. e. after 'z' follows 'a'). The same holds when he presses the down arrow key.

Initially, the text cursor is at position p.

Because Nam has a lot homework to do, he wants to complete this as fast as possible. Can you help him by calculating the minimum number of arrow keys presses to make the string to be a palindrome?

Input

The first line contains two space-separated integers n (1 ≤ n ≤ 105) and p (1 ≤ p ≤ n), the length of Nam's string and the initial position of the text cursor.

The next line contains n lowercase characters of Nam's string.

Output

Print the minimum number of presses needed to change string into a palindrome.

Sample test(s)
input
8 3
aeabcaez

output
6

Note

A string is a palindrome if it reads the same forward or reversed.

In the sample test, initial Nam's string is:  (cursor position is shown bold).

In optimal solution, Nam may do 6 following steps:

The result, , is now a palindrome.

由于没有删除操作,最后的回文串是什么样已经是确定的了, A-->A'  或 A'--->A 或到A和A'的中间值上下移动的次数是一样的,所以没有必要跨越中点

仅仅要计算出在一边的左右移动次数就能够了....

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>using namespace std;const int maxn=200100;
const int INF=0x3f3f3f3f;char str[maxn];
char rstr[maxn];
int n,p;int change[maxn][2];void getC()
{for(int i=0;i<n;i++){/// 0: A --> A'change[i][0]=max(str[i],rstr[i])-min(str[i],rstr[i]);change[i][0]=min(change[i][0],min(str[i],rstr[i])+26-max(str[i],rstr[i]));/// 1: A --> m <-- A'change[i][1]=change[i][0];}
}int main()
{cin>>n>>p;p--;cin>>str;int tt=n/2;if(n%2==0) tt--;if(p>tt){reverse(str,str+n);p=n-1-p;}memcpy(rstr,str,sizeof(str));reverse(rstr,rstr+n);getC();int temp=0;///改变字符的花费for(int i=0;i<=tt;i++){temp+=change[i][0];}///移动的花费///须要改变的左右边界int R=-1;for(int i=tt;i>=0;i--){if(change[i][0]!=0){R=i; break;}}int L=-1;for(int i=0;i<=tt;i++){if(change[i][0]!=0){L=i; break;}}if(L==-1||R==-1){puts("0");}else if(L==R){cout<<abs(p-L)+temp<<endl;}else{/// L <----> Rif(p>=L&&p<=R){int t=min(abs(R-p),abs(L-p));cout<<R-L+t+temp<<endl;}else if(p<L){cout<<abs(R-p)+temp<<endl;}else if(p>R){cout<<abs(L-p)+temp<<endl;}}return 0;
}

D. Valid Sets
time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

As you know, an undirected connected graph with n nodes and n - 1 edges is called a tree. You are given an integer d and a tree consisting of nnodes. Each node i has a value ai associated with it.

We call a set S of tree nodes valid if following conditions are satisfied:

  1. S is non-empty.
  2. S is connected. In other words, if nodes u and v are in S, then all nodes lying on the simple path between u and v should also be presented in S.
  3. .

Your task is to count the number of valid sets. Since the result can be very large, you must print its remainder modulo 1000000007 (109 + 7).

Input

The first line contains two space-separated integers d (0 ≤ d ≤ 2000) and n (1 ≤ n ≤ 2000).

The second line contains n space-separated positive integers a1, a2, ..., an(1 ≤ ai ≤ 2000).

Then the next n - 1 line each contain pair of integers u and v (1 ≤ u, v ≤ n) denoting that there is an edge between u and v. It is guaranteed that these edges form a tree.

Output

Print the number of valid sets modulo 1000000007.

Sample test(s)
input
1 4
2 1 3 2
1 2
1 3
3 4

output
8

input
0 3
1 2 3
1 2
2 3

output
3

input
4 8
7 8 7 5 4 6 4 10
1 6
1 2
5 8
1 3
3 5
6 7
3 4

output
41

Note

In the first sample, there are exactly 8 valid sets: {1}, {2}, {3}, {4}, {1, 2}, {1, 3}, {3, 4} and {1, 3, 4}. Set {1, 2, 3, 4} is not valid, because the third condition isn't satisfied. Set {1, 4} satisfies the third condition, but conflicts with the second condition.

树型DP,从每个节点走仅仅扩展和根节点 root  权值 在 root<=w[v]<=root+D 之内的点, DP[u]= 全部子节点(DP[v]+1)相乘

假设扩展到某个节点 w[v]==w[root]   则标记一下,不要反复走

#include <iostream>
#include <cstring>
#include <cstdio>
#include <algorithm>
#include <vector>using namespace std;typedef long long int LL;const int maxn=2222;
const LL mod=1000000007;int n,d,root;
LL w[maxn];
vector<int> g[maxn];
bool vis[maxn][maxn];LL dp[maxn];LL dfs(int u,int fa)
{dp[u]=1;for(int i=0,sz=g[u].size();i<sz;i++){int v=g[u][i];if(v==fa) continue;if(!((w[root]<=w[v])&&(w[v]<=w[root]+d))) continue;if(vis[root][v]) continue;if(w[root]==w[v]) vis[root][v]=vis[v][root]=true;int temp=dfs(v,u);dp[u]=(dp[u]+temp*dp[u])%mod;}return dp[u];
}int main()
{cin>>d>>n;for(int i=1; i<=n; i++)cin>>w[i];for(int i=0; i<n-1; i++){int a,b;cin>>a>>b;g[a].push_back(b);g[b].push_back(a);}LL sum=0;for(int i=1; i<=n; i++){root=i;sum=(sum+dfs(i,i))%mod;}cout<<sum<<endl;return 0;
}

E. LIS of Sequence
time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

The next "Data Structures and Algorithms" lesson will be about Longest Increasing Subsequence (LIS for short) of a sequence. For better understanding, Nam decided to learn it a few days before the lesson.

Nam created a sequence a consisting of n (1 ≤ n ≤ 105) elements a1, a2, ..., an (1 ≤ ai ≤ 105). A subsequence ai1, ai2, ..., aik where 1 ≤ i1 < i2 < ... < ik ≤ n is called increasing if ai1 < ai2 < ai3 < ... < aik. An increasing subsequence is called longest if it has maximum length among all increasing subsequences.

Nam realizes that a sequence may have several longest increasing subsequences. Hence, he divides all indexes i (1 ≤ i ≤ n), into three groups:

  1. group of all i such that ai belongs to no longest increasing subsequences.
  2. group of all i such that ai belongs to at least one but not every longest increasing subsequence.
  3. group of all i such that ai belongs to every longest increasing subsequence.

Since the number of longest increasing subsequences of a may be very large, categorizing process is very difficult. Your task is to help him finish this job.

Input

The first line contains the single integer n (1 ≤ n ≤ 105) denoting the number of elements of sequence a.

The second line contains n space-separated integers a1, a2, ..., an (1 ≤ ai ≤ 105).

Output

Print a string consisting of n characters. i-th character should be '1', '2' or '3' depending on which group among listed above index i belongs to.

Sample test(s)
input
1
4

output
3

input
4
1 3 2 5

output
3223

input
4
1 5 2 3

output
3133

Note

In the second sample, sequence a consists of 4 elements: {a1, a2, a3, a4} = {1, 3, 2, 5}. Sequence a has exactly 2 longest increasing subsequences of length 3, they are {a1, a2, a4} = {1, 3, 5} and {a1, a3, a4} = {1, 2, 5}.

In the third sample, sequence a consists of 4 elements: {a1, a2, a3, a4} = {1, 5, 2, 3}. Sequence a have exactly 1 longest increasing subsequence of length 3, that is {a1, a3, a4} = {1, 2, 3}.

Solution 2:

// Some notation is re-defined.

  • Let F1i be the length of LIS ending exactly at ai of sequence {a1, a2, ..., ai}.

  • Let F2i be the length of LIS beginning exactly at ai of sequence {ai, ai + 1, ..., an}.

  • l = length of LIS of {a1, a2, ..., an} = max{F1i} = max{F2j}.

  • Let Fi be the length of LIS of sequence {a1, a2, ..., ai - 1, ai + 1, ..., an} (i.e the length of LIS of initial sequence a after removing element ai).

  • Index i must in group:

    1) if F1i + F2i - 1 < l, otherwise:

    2) if Fi = l

    3) if Fi = l - 1

  • How to caculate Fi? We have: Fi = max{F1u + F2v} among 1 ≤ u < i < v ≤ n such that au < av. From this formula, we can use Segment tree to calculate Fi. Due to limitation of my English, it is really hard to write exactly how. I will post my code soon.

正反求两遍LIS,比較一下就可以.....
假设F1[i]+F2[j]-1==LIS 要用map记录下有没有同样的F1[i],F2[i]   有输出2 没有输出3
#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <set>
#include <map>using namespace std;const int maxn=100100;int n,a[maxn],b[maxn];
int f1[maxn],f2[maxn];
int v1[maxn],n1,v2[maxn],n2;
set<int> st;
map<pair<int,int>,int> mp;int r[maxn],rn;
int ans[maxn];int main()
{scanf("%d",&n);for(int i=0;i<n;i++){scanf("%d",a+i);r[rn++]=a[i];}sort(r,r+rn);rn=unique(r,r+rn)-r;///.....rhash.....for(int i=0;i<n;i++){int id=lower_bound(r,r+rn,a[i])-r;id=rn-1-id;b[n-1-i]=r[id];}int LIS=1;for(int i=0;i<n;i++){if(i==0){v1[n1++]=a[i];v2[n2++]=b[i];f1[0]=f2[0]=1;}else{int p1=lower_bound(v1,v1+n1,a[i])-v1;v1[p1]=a[i];if(p1==n1) n1++;f1[i]=p1+1;LIS=max(LIS,f1[i]);int p2=lower_bound(v2,v2+n2,b[i])-v2;v2[p2]=b[i];if(p2==n2) n2++;f2[i]=p2+1;}}for(int i=0;i<n;i++){int x=i,y=n-1-i;if(f1[x]+f2[y]-1<LIS)ans[i]=1;else if(f1[x]+f2[y]-1==LIS){ans[i]=4;mp[make_pair(f1[x],f2[y])]++;}}for(int i=0;i<n;i++){if(ans[i]==4){int x=i,y=n-1-i;if(mp[make_pair(f1[x],f2[y])]==1) ans[i]=3;else ans[i]=2;}printf("%d",ans[i]);if(i==n-1) putchar('\n');}return 0;
}

转载于:https://www.cnblogs.com/blfshiye/p/4295647.html

Codeforces Round #277 (Div. 2) 题解相关推荐

  1. Codeforces Round #514 (Div. 2)题解

    Codeforces Round #514 (Div. 2)题解 A 喵,直接模拟. B 枚举所有盖章时的,合法的,左上角的位置.能盖的话就盖一下.最后check一下图案是否相等即可 C 一轮一轮的扔 ...

  2. 贪心+构造 Codeforces Round #277 (Div. 2) C. Palindrome Transformation

    题目传送门 1 /* 2 贪心+构造:因为是对称的,可以全都左一半考虑,过程很简单,但是能想到就很难了 3 */ 4 /**************************************** ...

  3. Codeforces Round #182 (Div. 1)题解【ABCD】

    Codeforces Round #182 (Div. 1)题解 A题:Yaroslav and Sequence1 题意: 给你\(2*n+1\)个元素,你每次可以进行无数种操作,每次操作必须选择其 ...

  4. 【算法题解】Codeforces Round #817 (Div. 4)题解

    文章目录 Codeforces Round #817 (Div. 4)题解 A. Spell Check B. Colourblindness C. Word Game D. Line E. Coun ...

  5. Codeforces Round #747 (Div. 2)题解

    Codeforces Round #747 (Div. 2)题解 (本博客将持续更新以后每场CF div2的题解,喜欢ACM.OI的小伙伴记得点个关注哟) 昨天夜晚刷网络流刷入迷了,渐渐就忘记了我还要 ...

  6. Codeforces Round #789 (Div. 2)题解

    Codeforces Round #789 (Div. 2)题解 A. Tokitsukaze and All Zero Sequence 原题链接 算法标签 贪心 排序 思路 情况一:数组存在零 → ...

  7. Codeforces Round #748 (Div. 3) 题解 完整A~G

    Codeforces Round #748 (Div. 3) 题解 A. Elections 题意 已知竞选中三个候选人的当前得票数 a , b , c a,b,c a,b,c,现在可以增加任何一个人 ...

  8. Codeforces Round #533 (Div. 2)题解

    link orz olinr AK Codeforces Round #533 (Div. 2) 中文水平和英文水平都太渣..翻译不准确见谅 T1.给定n<=1000个整数,你需要钦定一个值t, ...

  9. Codeforces Round #734 (Div. 3) 题解

    Hello大家好,今天给大家带来的是 Codeforces Round #734 (Div. 3) 的全题目讲解. 本文链接:https://www.lanqiao.cn/questions/2040 ...

最新文章

  1. 03 ORA系列:ORA-00942 表或视图不存在 table or view does not exist
  2. Java SE 12扩展Switch语句/表达式完整指南
  3. ios 主题切换 思路_iOS 使用 NSObject 的分类实现快速切换主题
  4. 音乐播放插件Aplayer+WebAPI的使用【附下载】
  5. 实验4 数据库的连接查询
  6. linux 11Gasm启动crs,11GR2重建CRS
  7. [HNOI2008]越狱(luogu P3197)
  8. c语言结构体的实例使用
  9. bin文件转换成html,bin如何改成mp4
  10. ESP8266 教程1 — ESP8266硬件平台介绍
  11. “十四五”国家应急体系规划发布 智慧应急成为总体建设目标之一
  12. 锂电池电量百分比计算_怎样估计锂电池剩余电量SOC
  13. navicat can not load oci dll,193,126
  14. android壁纸背景,android – 选择动态壁纸的背景
  15. 新股发行制度五年改革历程
  16. XILINX-FPGA下载工具--CH347FPGADownloader
  17. html文字发亮_css实现发光文字及一点点js特效
  18. 实践:前后端分离实现JWT登录验证,包括前、后端配置
  19. 固网服务器win7系统驱动,固网HU-1608n驱动
  20. 通达信板块监控指标_板块强弱指标(通达信)

热门文章

  1. Javascript学习笔记1 数论
  2. IE Firefox css 差别 [转]
  3. 计算机应用基础课程基本要求,计算机应用基础课程标准
  4. 并查集(UnionFindSet)
  5. C++error:找不到指定文件
  6. Eclipse中要导出jar包中引用了第三方jar包怎么办
  7. 少儿编程100讲轻松学python(十一)-python如何保留小数点位数
  8. 你也在你的应用上添加B站上的弹幕效果
  9. 为啥这么多程序员大佬学习Cortex-M3
  10. 云计算系统是大规模计算机系统吗,云计算的系统架构及技术探析